(***********************************************************************)
(*                                                                     *)
(*                               TAToo                                 *)
(*                                                                     *)
(*                     Kim Nguyen, LRI UMR8623                         *)
(*                   Université Paris-Sud & CNRS                       *)
(*                                                                     *)
(*  Copyright 2010-2013 Université Paris-Sud and Centre National de la *)
(*  Recherche Scientifique. All rights reserved.  This file is         *)
(*  distributed under the terms of the GNU Lesser General Public       *)
(*  License, with the special exception on linking described in file   *)
(*  ../LICENSE.                                                        *)
(*                                                                     *)
(***********************************************************************)


type stats = private { mutable pass : int;
               tree_size : int;
               mutable fetch_trans_cache_access : int;
               mutable fetch_trans_cache_hit : int;
               mutable eval_trans_cache_access : int;
               mutable eval_trans_cache_hit : int;
               mutable nodes_per_run : int list;
             }

module Make (T : Tree.S) (L : Node_list.S with type node = T.node) :
  sig
    val eval : Ata.t -> T.t -> L.t -> L.t
    val full_eval : Ata.t -> T.t -> L.t -> (State.t * L.t) list
    val stats : unit -> stats
  end
